import linkahead as db
import os
import configparser
from importlib_resources import files, as_file

with as_file(files('loan').joinpath('default_config.ini')) as default_config_path:
    user_config_path = os.path.expanduser('~/.linkahead_loan.ini')
    config = configparser.ConfigParser()
    config.read([default_config_path, user_config_path])
    global rts, ps
    rts = config['RecordTypes']
    ps = config['Properties']

# RecordTypes
BOX = db.RecordType(name=rts['BOX'])
PERSON = db.RecordType(name=rts['PERSON'])
LOAN = db.RecordType(name=rts['LOAN'])
LOCATION = db.RecordType(name=rts['LOCATION'])

# Properties
FIRST_NAME = db.Property(name=ps['FIRST_NAME'], datatype=db.TEXT)
LAST_NAME = db.Property(name=ps['LAST_NAME'], datatype=db.TEXT)
EMAIL = db.Property(name=ps['EMAIL'], datatype=db.TEXT)

DESTINATION = db.Property(name=ps['DESTINATION'], datatype=rts['LOCATION'])
RETURNLOCATION = db.Property(name=ps['RETURNLOCATION'], datatype=rts['LOCATION'])
COMMENT = db.Property(name=ps['COMMENT'], datatype=db.TEXT)
EXHAUST_CONTENTS = db.Property(name=ps['EXHAUST_CONTENTS'], datatype=db.BOOLEAN)
BORROWER = db.Property(name=ps['BORROWER'], datatype=rts['PERSON'])
CONTENT = db.Property(name=ps['CONTENT'], datatype=db.TEXT)
LOAN_REQUESTED = db.Property(name=ps['LOAN_REQUESTED'], datatype=db.DATETIME)
EXPECTED_RETURN = db.Property(name=ps['EXPECTED_RETURN'], datatype=db.DATETIME)
LOAN_ACCEPTED = db.Property(name=ps['LOAN_ACCEPTED'], datatype=db.DATETIME)
LENT = db.Property(name=ps['LENT'], datatype=db.DATETIME)
RETURN_REQUESTED = db.Property(name=ps['RETURN_REQUESTED'], datatype=db.DATETIME)
RETURN_ACCEPTED = db.Property(name=ps['RETURN_ACCEPTED'], datatype=db.DATETIME)
RETURNED = db.Property(name=ps['RETURNED'], datatype=db.DATETIME)
BOX_NUMBER = db.Property(name=ps['BOX_NUMBER'], datatype=db.TEXT)

# Other Strings
# TODO: Adapt datamodel and remove name override
BOX_RETURNED = "Box (returned)"
BOX_BORROWED = "Box (borrowed)"
